function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import locale from "./../../locale";
import DateComboUtils from "./../Combo/Utils";

// eslint-disable-next-line
export default {
  // value不存在时默认为当天
  getValue: function getValue(_ref) {
    var value = _ref.value;
    if (!value) {
      value = [{
        type: 'date',
        id: 'start',
        name: locale('开始时间', 'start_time'),
        value: new Date()
      }, {
        type: 'date',
        id: 'end',
        name: locale('结束时间', 'end_time'),
        value: new Date()
      }];
    }
    return value;
  },
  // 显示名称
  getDisplayValue: function getDisplayValue(_ref2) {
    var type = _ref2.type,
      format = _ref2.format,
      value = _ref2.value,
      separator = _ref2.separator;
    if (!Array.isArray(value) || value.length < 2) {
      return '';
    }
    var displayValue = [];
    var _iterator = _createForOfIteratorHelper(value),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var current = _step.value;
        if ((current === null || current === void 0 ? void 0 : current.value) instanceof Date === false) {
          return '';
        }
        displayValue.push(DateComboUtils.getDisplayValue({
          type: type,
          format: format,
          value: current.value
        }));
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
    return displayValue.join(separator || ' ~ ');
  }
};