function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["separator", "caption", "min", "max", "type", "format", "daysLimit", "enableAlias", "ranges", "onError", "ModalProps", "value"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require PrototypeDate.js和PrototypeString.js
import React, { forwardRef, useImperativeHandle, useRef } from 'react';
import Combo from "./../../Picker/Combo";
import Modal from "./../RangeModal";
import Utils from "./Utils";
import locale from "./../../locale";
import { jsx as _jsx } from "react/jsx-runtime";
var RangeCombo = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref2;
  var separator = _ref.separator,
    caption = _ref.caption,
    min = _ref.min,
    max = _ref.max,
    type = _ref.type,
    format = _ref.format,
    daysLimit = _ref.daysLimit,
    _ref$enableAlias = _ref.enableAlias,
    enableAlias = _ref$enableAlias === void 0 ? true : _ref$enableAlias,
    _ref$ranges = _ref.ranges,
    ranges = _ref$ranges === void 0 ? (_ref2 = {}, _defineProperty(_ref2, locale('今天', 'datepicker-tooltip_today'), [new Date(), new Date()]), _defineProperty(_ref2, locale('昨天', 'datepicker-tooltip_yesterday'), [new Date().prevDate(), new Date().prevDate()]), _defineProperty(_ref2, locale('本月', 'datepicker-tooltip_this_month'), [new Date().firstMonthDate(), new Date()]), _defineProperty(_ref2, locale('上月', 'datepicker-tooltip_last_month'), [new Date().prevMonth().firstMonthDate(), new Date().prevMonth().lastMonthDate()]), _defineProperty(_ref2, locale('最近7天', 'datepicker-tooltip_last_days', ['7']), [new Date().prevDate(6), new Date()]), _defineProperty(_ref2, locale('最近30天', 'datepicker-tooltip_last_days', ['30']), [new Date().prevDate(29), new Date()]), _defineProperty(_ref2, locale('自定义时间', 'datepicker-tooltip_custom_date'), _defineProperty({}, locale('自定义时间', 'datepicker-tooltip_custom_date'), null)), _ref2) : _ref$ranges,
    onError = _ref.onError,
    _ref$ModalProps = _ref.ModalProps,
    ModalProps = _ref$ModalProps === void 0 ? {} : _ref$ModalProps,
    value = _ref.value,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    var _rootRef$current, _rootRef$current2, _rootRef$current3, _rootRef$current4;
    return {
      rootDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current = rootRef.current) === null || _rootRef$current === void 0 ? void 0 : _rootRef$current.rootDOM,
      modalDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current2 = rootRef.current) === null || _rootRef$current2 === void 0 ? void 0 : _rootRef$current2.modalDOM,
      instance: instance.current,
      getRootDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current3 = rootRef.current) === null || _rootRef$current3 === void 0 ? void 0 : _rootRef$current3.getRootDOM,
      getModalDOM: rootRef === null || rootRef === void 0 ? void 0 : (_rootRef$current4 = rootRef.current) === null || _rootRef$current4 === void 0 ? void 0 : _rootRef$current4.getModalDOM,
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });

  // 实例化
  instance.current = {
    getDisplayValue: function getDisplayValue(value) {
      return Utils.getDisplayValue({
        // 用于显示别名
        ranges: enableAlias ? ranges : null,
        // 按日期类型显示
        type: type,
        // 按自定义格式显示
        format: format,
        // 分割符
        separator: separator,
        value: value
      });
    }
  };
  // 显示值
  var displayValue = instance.current.getDisplayValue(value);
  return /*#__PURE__*/_jsx(Combo, _objectSpread(_objectSpread({
    value: displayValue,
    ModalComponent: Modal,
    ModalProps: _objectSpread({
      separator: separator,
      caption: caption,
      value: value,
      min: min,
      max: max,
      type: type,
      ranges: ranges,
      daysLimit: daysLimit,
      onError: onError
    }, ModalProps)
  }, props), {}, {
    ref: rootRef
  }));
});
export default RangeCombo;