import DateComboUtils from "./../Combo/Utils";

// eslint-disable-next-line
export default {
  // 显示名称
  getDisplayValue: function getDisplayValue(_ref) {
    var ranges = _ref.ranges,
      type = _ref.type,
      format = _ref.format,
      value = _ref.value,
      separator = _ref.separator;
    if (!Array.isArray(value) || value.length !== 2) {
      return '';
    }
    var start = value[0];
    var end = value[1];
    if (start instanceof Date === false || end instanceof Date === false) {
      return '';
    }
    var displayValue = [];

    // 显示别名
    if (Object.prototype.toString.call(ranges) === '[object Object]') {
      for (var alias in ranges) {
        var range = ranges[alias];
        if (!Array.isArray(range) || range.length !== 2) {
          continue;
        }
        var rangeStart = range[0];
        var rangeEnd = range[1];
        if (rangeStart instanceof Date === false || rangeEnd instanceof Date === false) {
          continue;
        }

        // 区间相同则显示别名
        if (DateComboUtils.getDisplayValue({
          type: type,
          format: format,
          value: start
        }) === DateComboUtils.getDisplayValue({
          type: type,
          format: format,
          value: rangeStart
        }) && DateComboUtils.getDisplayValue({
          type: type,
          format: format,
          value: end
        }) === DateComboUtils.getDisplayValue({
          type: type,
          format: format,
          value: rangeEnd
        })) {
          return alias;
        }
      }
    }

    // 显示日期
    displayValue.push(DateComboUtils.getDisplayValue({
      type: type,
      format: format,
      value: start
    }));
    displayValue.push(DateComboUtils.getDisplayValue({
      type: type,
      format: format,
      value: end
    }));
    return displayValue.join(separator || ' ~ ');
  }
};