function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["type", "autoFit", "readOnly", "disabled", "inputProps", "defaultValue", "value", "precision", "max", "min", "placeholder", "maxLength", "autoFocus", "autoSelect", "licon", "liconProps", "ricon", "riconProps", "allowClear", "clearProps", "rcaption", "children", "onClick", "onCompositionStart", "onCompositionUpdate", "onCompositionEnd", "onInput", "onChange", "onBlur", "onFocus"],
  _excluded2 = ["visible"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect, useState } from 'react';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var InputText = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'text' : _ref$type,
    autoFit = _ref.autoFit,
    readOnly = _ref.readOnly,
    disabled = _ref.disabled,
    _ref$inputProps = _ref.inputProps,
    inputProps = _ref$inputProps === void 0 ? {} : _ref$inputProps,
    defaultValue = _ref.defaultValue,
    value = _ref.value,
    precision = _ref.precision,
    max = _ref.max,
    min = _ref.min,
    placeholder = _ref.placeholder,
    maxLength = _ref.maxLength,
    autoFocus = _ref.autoFocus,
    autoSelect = _ref.autoSelect,
    licon = _ref.licon,
    liconProps = _ref.liconProps,
    ricon = _ref.ricon,
    riconProps = _ref.riconProps,
    allowClear = _ref.allowClear,
    clearProps = _ref.clearProps,
    rcaption = _ref.rcaption,
    children = _ref.children,
    onClick = _ref.onClick,
    onCompositionStart = _ref.onCompositionStart,
    onCompositionUpdate = _ref.onCompositionUpdate,
    onCompositionEnd = _ref.onCompositionEnd,
    onInput = _ref.onInput,
    onChange = _ref.onChange,
    onBlur = _ref.onBlur,
    onFocus = _ref.onFocus,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  var inputRef = useRef(null);
  var fitRef = useRef(null);
  var clearRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      inputDOM: inputRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInputDOM: function getInputDOM() {
        return inputRef.current;
      },
      correctValue: correctValue,
      focus: _focus
    };
  });
  useEffect(function () {
    var val = inputRef.current.value;
    // 更新清除按钮和自适应的高度
    updateClear(val);
    updateAutoFit(val);
    // 自动获取焦点
    if (autoFocus) {
      _focus();
    }
  }, []); // eslint-disable-line

  useEffect(function () {
    updateContainer();
  }, [value]); // eslint-disable-line

  // 更新文本框高度和清空按钮
  function updateContainer() {
    if (!(rootRef !== null && rootRef !== void 0 && rootRef.current)) return;
    if (rootRef.current.inputTimeout) {
      clearTimeout(rootRef.current.inputTimeout);
    }
    rootRef.current.inputTimeout = setTimeout(function () {
      if (!(inputRef !== null && inputRef !== void 0 && inputRef.current)) return;
      var val = inputRef.current.value;
      // 更新清除按钮和自适应的高度
      updateClear(val);
      updateAutoFit(val);
    }, 100);
  }

  // 更新清除按钮
  function updateClear(val) {
    if (typeof val === 'number') {
      // eslint-disable-next-line
      val = String(val);
    }
    // 不显示清空
    if (!allowClear) {
      var _clearRef$current, _clearRef$current$cla;
      if (clearRef !== null && clearRef !== void 0 && (_clearRef$current = clearRef.current) !== null && _clearRef$current !== void 0 && (_clearRef$current$cla = _clearRef$current.classList) !== null && _clearRef$current$cla !== void 0 && _clearRef$current$cla.add) {
        clearRef.current.classList.add('hide');
      }
      return;
    }

    // 根据值判断是否显示清空
    if (val) {
      var _clearRef$current2, _clearRef$current2$cl;
      if (clearRef !== null && clearRef !== void 0 && (_clearRef$current2 = clearRef.current) !== null && _clearRef$current2 !== void 0 && (_clearRef$current2$cl = _clearRef$current2.classList) !== null && _clearRef$current2$cl !== void 0 && _clearRef$current2$cl.remove) {
        clearRef.current.classList.remove('hide');
      }
    } else {
      var _clearRef$current3, _clearRef$current3$cl;
      if (clearRef !== null && clearRef !== void 0 && (_clearRef$current3 = clearRef.current) !== null && _clearRef$current3 !== void 0 && (_clearRef$current3$cl = _clearRef$current3.classList) !== null && _clearRef$current3$cl !== void 0 && _clearRef$current3$cl.add) {
        clearRef.current.classList.add('hide');
      }
    }
  }

  // 自动扩充功能
  function updateAutoFit(val) {
    if (!autoFit) return;
    fitRef.current.children[0].innerText = val;
    // 多行文本框使用样式宽高100%, 放弃使用js控制高度
    // inputRef.current.style.height = fitRef.current.clientHeight + 'px'
  }

  // 矫正最大长度和小数位截取
  function correctValue(val) {
    if (val === undefined || val === '') return val;
    if (typeof val !== 'string' && typeof val !== 'number') return '';
    // eslint-disable-next-line
    if (typeof val === 'number') val = String(val);
    // 最大长度
    if (maxLength && val && val.length > maxLength) {
      // eslint-disable-next-line
      val = val.substring(0, maxLength);
    }
    // 小数位截取
    if (typeof precision === 'number') {
      if (val.indexOf('.') !== -1) {
        // eslint-disable-next-line
        val = val.substring(0, val.indexOf('.') + Number(precision) + 1);
      }
    }
    // 数值框
    if (type === 'number' && val) {
      // eslint-disable-next-line
      val = Number(val);
    }
    return val;
  }

  // 获取焦点
  function _focus() {
    if (disabled || readOnly || !inputRef.current) return;
    inputRef.current.focus();
    // 只有获取焦点以后才能选中
    if (autoSelect) {
      inputRef.current.select();
    }
  }

  // 获取焦点时, 如果readOnly或者disabled时, 需要立即失去焦点, 解决ios会出现底栏的问题
  function handleFocus(e) {
    if (readOnly || disabled) {
      e.target.blur();
      return;
    }
    if (onFocus) onFocus(e);
  }

  // 清空按钮控制
  function handleInput(e) {
    // 非受控组件需要操作DOM
    if (value === undefined) {
      updateContainer();
    }

    // Callback
    if (onInput) onInput(e);
  }

  // 修改值
  function handleChange(e) {
    var _target$validity;
    var target = e.target;
    var val = target.value;
    // 输入值不合法
    if (target !== null && target !== void 0 && (_target$validity = target.validity) !== null && _target$validity !== void 0 && _target$validity.badInput) {
      val = '';
    }

    // 矫正maxLength和小数点位数
    val = correctValue(val);

    // 非受控组件需要操作DOM
    if (value === undefined) {
      // 最大长度
      if (maxLength && target.value && target.value.length > maxLength) {
        target.value = val;
      }
      // 小数位截取
      if (typeof precision === 'number' && target.value.indexOf('.') !== -1 && target.value.split('.')[1].length > precision) {
        target.value = val;
      }
    }
    if (onChange) {
      onChange(val);
    }
  }

  // 数值框失去焦点, 校验最大值和最小值
  function handleBlur(e) {
    if (readOnly || disabled) {
      return;
    }
    var target = e.target;
    var val = target.value;
    if (val && !isNaN(val)) {
      // 输入时只校验最大值、小数点、最大长度、返回错误
      if (typeof max === 'number') {
        if (Number(val) > Number(max)) val = max;
      }
      if (typeof min === 'number') {
        if (Number(val) < Number(min)) val = min;
      }

      // 纠正数字
      val = correctValue(val);

      // 修改完回调
      if (val !== value) {
        if (onChange) onChange(val);
      }
    }
    if (onBlur) onBlur(e);
  }

  // 点击清除
  function handleClear(e) {
    e.stopPropagation();
    // 获取焦点
    _focus();

    // Callback
    if (onChange) {
      onChange('');
    }

    // 非受控组件需要操作DOM
    if (value === undefined) {
      var _inputRef$current;
      updateContainer();
      if (inputRef !== null && inputRef !== void 0 && (_inputRef$current = inputRef.current) !== null && _inputRef$current !== void 0 && _inputRef$current.value) {
        inputRef.current.value = '';
      }
    } else {
      // 正常onChange会触发value监听, 但有可能value未变, 手动再触发一遍清空
      updateClear('');
    }
  }

  // render
  function getInputDOM() {
    // 剔除掉onClick事件, 因为在容器onClick已经回调了
    var inputVisible = inputProps.visible,
      otherInputProps = _objectWithoutProperties(inputProps, _excluded2);
    // if (inputVisible === false) return null
    // autoFit类型
    if (autoFit) {
      // pre的左右padding
      var fitLeft = 0;
      var fitRight = 0;
      if (otherInputProps.style) {
        if (otherInputProps.style.padding) {
          var paddingValues = otherInputProps.style.padding.split(' ');
          if (paddingValues.length === 1) {
            fitLeft = paddingValues[0];
            fitRight = paddingValues[0];
          } else if (paddingValues.length === 2) {
            fitLeft = paddingValues[1];
            fitRight = paddingValues[1];
          } else if (paddingValues.length === 4) {
            fitLeft = paddingValues[1];
            fitRight = paddingValues[3];
          }
        } else if (otherInputProps.style.paddingLeft || otherInputProps.style.paddingRight) {
          fitLeft = otherInputProps.style.paddingLeft || '0';
          fitRight = otherInputProps.style.paddingRight || '0';
        }
      }
      return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, otherInputProps), {}, {
        className: "input-fit-wrapper".concat(otherInputProps.className ? ' ' + otherInputProps.className : '').concat(inputVisible === false ? ' hide' : ''),
        children: [/*#__PURE__*/_jsx("div", {
          className: "input-fit",
          children: /*#__PURE__*/_jsx("textarea", {
            ref: inputRef,
            autoFocus: autoFocus,
            value: correctValue(value),
            defaultValue: correctValue(defaultValue),
            maxLength: maxLength,
            readOnly: readOnly,
            disabled: disabled,
            placeholder: placeholder,
            onChange: handleChange,
            onInput: handleInput,
            onBlur: handleBlur,
            onFocus: handleFocus
          })
        }), /*#__PURE__*/_jsx("pre", {
          ref: fitRef,
          style: {
            left: fitLeft,
            right: fitRight
          },
          children: /*#__PURE__*/_jsx("span", {})
        })]
      }));
    }
    // textarea类型
    if (type === 'textarea') {
      // 如果值绑定属性,则只有通过父组件的prop来改变值
      return /*#__PURE__*/_jsx("textarea", _objectSpread(_objectSpread({
        ref: inputRef
      }, otherInputProps), {}, {
        autoFocus: autoFocus,
        value: correctValue(value),
        defaultValue: correctValue(defaultValue),
        maxLength: maxLength,
        readOnly: readOnly,
        disabled: disabled,
        placeholder: placeholder,
        onChange: handleChange,
        onInput: handleInput,
        onBlur: handleBlur,
        onFocus: handleFocus,
        className: "input-textarea".concat(otherInputProps.className ? ' ' + otherInputProps.className : '').concat(inputVisible === false ? ' hide' : '')
      }));
    }
    // 其它类型
    return /*#__PURE__*/_jsx("input", _objectSpread(_objectSpread({
      ref: inputRef,
      type: type
    }, otherInputProps), {}, {
      className: "input-text".concat(otherInputProps.className ? ' ' + otherInputProps.className : '').concat(inputVisible === false ? ' hide' : ''),
      defaultValue: correctValue(defaultValue),
      value: correctValue(value),
      min: typeof min === 'number' ? min : '',
      max: typeof max === 'number' ? max : '',
      maxLength: maxLength,
      disabled: disabled,
      readOnly: readOnly,
      placeholder: placeholder,
      onChange: handleChange,
      onInput: handleInput,
      autoFocus: autoFocus,
      onBlur: handleBlur,
      onFocus: handleFocus
    }));
  }
  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "input-wrapper".concat(props.className ? ' ' + props.className : '').concat(disabled ? ' disabled' : '').concat(readOnly ? ' readonly' : ''),
    onClick: onClick,
    ref: rootRef,
    children: [licon && licon, liconProps && /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({}, liconProps), {}, {
      className: "licon icon".concat(liconProps !== null && liconProps !== void 0 && liconProps.className ? ' ' + (liconProps === null || liconProps === void 0 ? void 0 : liconProps.className) : '')
    })), getInputDOM(), children && children, /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({
      ref: clearRef
    }, clearProps), {}, {
      className: "input-clear".concat(clearProps !== null && clearProps !== void 0 && clearProps.className ? ' ' + (clearProps === null || clearProps === void 0 ? void 0 : clearProps.className) : ''),
      onClick: handleClear
    })), riconProps && /*#__PURE__*/_jsx("i", _objectSpread(_objectSpread({}, riconProps), {}, {
      className: "ricon icon".concat(riconProps !== null && riconProps !== void 0 && riconProps.className ? ' ' + (riconProps === null || riconProps === void 0 ? void 0 : riconProps.className) : '')
    })), ricon && ricon, rcaption && rcaption]
  }));
});
export default InputText;