function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["multiple", "checkStrictly", "onlyLeafCheck", "checkable", "selectable", "list", "defaultValue", "value", "searchProps", "throttle", "onChange", "showIcon", "itemRender", "searchRender"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useMemo, useState, useRef } from 'react';
import Tree from 'rc-tree';
import Search from "./../components/Search";
import Utils from "./Utils";

// 树控件
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
function TreePicker(_ref) {
  var multiple = _ref.multiple,
    _ref$checkStrictly = _ref.checkStrictly,
    checkStrictly = _ref$checkStrictly === void 0 ? false : _ref$checkStrictly,
    onlyLeafCheck = _ref.onlyLeafCheck,
    _ref$checkable = _ref.checkable,
    checkable = _ref$checkable === void 0 ? true : _ref$checkable,
    selectable = _ref.selectable,
    list = _ref.list,
    defaultValue = _ref.defaultValue,
    value = _ref.value,
    searchProps = _ref.searchProps,
    _ref$throttle = _ref.throttle,
    throttle = _ref$throttle === void 0 ? 500 : _ref$throttle,
    onChange = _ref.onChange,
    _ref$showIcon = _ref.showIcon,
    showIcon = _ref$showIcon === void 0 ? false : _ref$showIcon,
    itemRender = _ref.itemRender,
    searchRender = _ref.searchRender,
    props = _objectWithoutProperties(_ref, _excluded);
  // 扁平化数据, 搜索时需要展开的子级
  var flattenListRef = useRef(Array.isArray(list) && list.length ? Object.clone(list).flattenTree() : []);
  useEffect(function () {
    // 第一次不走
    if (!flattenListRef.current.isFirst) {
      flattenListRef.current.isFirst = true;
    }
    // 第二次开始更新
    else {
      if (Array.isArray(list) && list.length) {
        flattenListRef.current = Object.clone(list).flattenTree();
      }
    }

    // 展开关键字
    handleExpandedKeys();
    // eslint-disable-next-line
  }, [list]);

  // 展开的id
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    expandedKeys = _useState2[0],
    setExpandedKeys = _useState2[1];

  // 选中子级时自动展开父级, 但为设为自动true时无法收缩, 所以收缩时需要再设为false(expandedKeys如果带入了父级则不需要自动展开父级)
  // const [autoExpandParent, setAutoExpandParent] = useState(true) // autoExpandParent此属性会引发卡顿, 不建议使用
  var handleExpand = function handleExpand(newExpandedKeys) {
    setExpandedKeys(newExpandedKeys);
    // setAutoExpandParent(false)
  };

  // 搜索
  var _useState3 = useState((searchProps === null || searchProps === void 0 ? void 0 : searchProps.value) || ''),
    _useState4 = _slicedToArray(_useState3, 2),
    keyword = _useState4[0],
    setKeyword = _useState4[1];

  // 展开keys属性
  var expandProp = searchProps !== null && searchProps !== void 0 && searchProps.visible ? {
    // 点击展开(expandedKeys如果带入了父级则不需要自动展开父级)
    onExpand: handleExpand,
    // autoExpandParent: autoExpandParent,
    // 搜索时展开的子级
    expandedKeys: expandedKeys
  } : {};

  // 展开关键字
  function handleExpandedKeys() {
    // 没有关键字则没有展开项
    if (!keyword || Object.isEmptyObject(list)) {
      setExpandedKeys([]);
    } else {
      // 展开的keys
      var newExpandedKeys = Utils.getExpandedKeys(keyword, flattenListRef.current);
      setExpandedKeys(newExpandedKeys);

      // setAutoExpandParent(true)
    }
  }

  // 修改
  function handleChange(ids, checkedObject) {
    var checkedNodes = (checkedObject === null || checkedObject === void 0 ? void 0 : checkedObject.checkedNodes) || [];
    // multiple未传则为必选单选
    if (multiple === undefined) {
      if (checkedObject !== null && checkedObject !== void 0 && checkedObject.node) checkedNodes = [checkedObject.node];
    }
    // multiple为false时为可取消单选
    if (multiple === false) {
      if (checkedNodes.length > 1) {
        if (checkedObject !== null && checkedObject !== void 0 && checkedObject.node) checkedNodes = [checkedObject.node];
      }
    }
    if (onChange) onChange(checkedNodes);
  }

  // 构建渲染数据, 支持关键字搜索
  var treeData = Utils.getTreeData({
    list: list,
    onlyLeafCheck: onlyLeafCheck,
    keyword: keyword,
    itemRender: itemRender
  });

  // 构建选中项
  var checkedKeysProp = useMemo(function () {
    return Utils.getCheckedKeysProp(value, defaultValue);
  }, [value, defaultValue]);
  return /*#__PURE__*/_jsxs(_Fragment, {
    children: [/*#__PURE__*/_jsx(Search, {
      value: keyword,
      onChange: function onChange(newKeyword) {
        keyword = newKeyword;
        setKeyword(newKeyword);
        handleExpandedKeys();
      }
      // 搜索
      ,
      searchProps: searchProps
      // 节流时长
      ,
      throttle: throttle
      // 自定义渲染
      ,
      searchRender: searchRender
    }), /*#__PURE__*/_jsx(Tree, _objectSpread(_objectSpread(_objectSpread({
      fieldNames: {
        key: 'id'
      },
      treeData: treeData
      // 经测试multiple不生效
      // multiple={multiple}
      // 选中项属性
    }, checkedKeysProp), {}, {
      // 选中checkbox
      onCheck: handleChange
      // 点击(用于解决checkable为false时没有checkbox时onChange)
      ,
      onSelect: handleChange
      // 展开keys属性
    }, expandProp), {}, {
      // 树默认设置
      showIcon: showIcon,
      onlyLeafCheck: onlyLeafCheck,
      checkStrictly: checkStrictly,
      checkable: checkable,
      selectable: checkable ? false : true
    }, props))]
  });
}
export default TreePicker;