function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["visible", "value", "onSearch"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import Input from "./../../Input";
import locale from "./../../locale"; // 国际化

// 搜索框
import { jsx as _jsx } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
var Search = function Search(_ref) {
  var value = _ref.value,
    onChange = _ref.onChange,
    searchProps = _ref.searchProps,
    _ref$throttle = _ref.throttle,
    throttle = _ref$throttle === void 0 ? 500 : _ref$throttle,
    searchRender = _ref.searchRender;
  // 搜索项属性
  var _ref2 = searchProps || {},
    searchVisible = _ref2.visible,
    searchValue = _ref2.value,
    onSearch = _ref2.onSearch,
    otherSearchProps = _objectWithoutProperties(_ref2, _excluded);
  function handleChange(newKeyword) {
    // 节流搜索
    if (window.timeout) {
      window.clearTimeout(window.timeout);
    }
    window.timeout = window.setTimeout(function () {
      if (onChange) onChange(newKeyword);
      if (onSearch) onSearch(newKeyword);
    }, throttle);
  }

  // 不显示则不渲染
  if (!searchVisible) return null;

  // 自定义渲染
  if (typeof searchRender === 'function') {
    var searchNode = searchRender({
      value: value,
      onChange: onChange,
      // 搜索
      searchProps: searchProps,
      // 节流时长
      throttle: throttle
    });
    if (searchNode) return searchNode;
  }
  return /*#__PURE__*/_jsx(_Fragment, {
    children: searchVisible && /*#__PURE__*/_jsx(Input.Text, _objectSpread({
      placeholder: locale('搜索', 'input_search_placeholder'),
      onChange: handleChange,
      className: "treepicker-search-input",
      defaultValue: value,
      allowClear: true
    }, otherSearchProps))
  });
};
export default Search;